diff -ruNpw nginx-1.1.15/src/core/ngx_open_file_cache.c nginx-1.1.15_zls/src/core/ngx_open_file_cache.c
--- nginx-1.1.15/src/core/ngx_open_file_cache.c	2012-02-15 20:18:55.000000000 +0800
+++ nginx-1.1.15_zls/src/core/ngx_open_file_cache.c	2012-02-27 11:01:11.825412233 +0800
@@ -1131,7 +1131,6 @@ ngx_open_file_lookup(ngx_open_file_cache
 
         /* hash == node->key */
 
-        do {
             file = (ngx_cached_open_file_t *) node;
 
             rc = ngx_strcmp(name->data, file->name);
@@ -1141,10 +1140,6 @@ ngx_open_file_lookup(ngx_open_file_cache
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && hash == node->key);
-
-        break;
     }
 
     return NULL;
diff -ruNpw nginx-1.1.15/src/core/ngx_resolver.c nginx-1.1.15_zls/src/core/ngx_resolver.c
--- nginx-1.1.15/src/core/ngx_resolver.c	2012-02-13 23:41:11.000000000 +0800
+++ nginx-1.1.15_zls/src/core/ngx_resolver.c	2012-02-27 11:01:37.170996233 +0800
@@ -1688,7 +1688,6 @@ ngx_resolver_lookup_name(ngx_resolver_t 
 
         /* hash == node->key */
 
-        do {
             rn = (ngx_resolver_node_t *) node;
 
             rc = ngx_memn2cmp(name->data, rn->name, name->len, rn->nlen);
@@ -1698,10 +1697,6 @@ ngx_resolver_lookup_name(ngx_resolver_t 
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && hash == node->key);
-
-        break;
     }
 
     /* not found */
diff -ruNpw nginx-1.1.15/src/event/ngx_event_openssl.c nginx-1.1.15_zls/src/event/ngx_event_openssl.c
--- nginx-1.1.15/src/event/ngx_event_openssl.c	2012-01-30 15:38:27.000000000 +0800
+++ nginx-1.1.15_zls/src/event/ngx_event_openssl.c	2012-02-27 11:00:52.660214483 +0800
@@ -1801,7 +1801,6 @@ ngx_ssl_get_cached_session(ngx_ssl_conn_
 
         /* hash == node->key */
 
-        do {
             sess_id = (ngx_ssl_sess_id_t *) node;
 
             rc = ngx_memn2cmp(id, sess_id->id,
@@ -1835,10 +1834,6 @@ ngx_ssl_get_cached_session(ngx_ssl_conn_
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && hash == node->key);
-
-        break;
     }
 
 done:
@@ -1908,7 +1903,6 @@ ngx_ssl_remove_session(SSL_CTX *ssl, ngx
 
         /* hash == node->key */
 
-        do {
             sess_id = (ngx_ssl_sess_id_t *) node;
 
             rc = ngx_memn2cmp(id, sess_id->id, len, (size_t) node->data);
@@ -1929,10 +1923,6 @@ ngx_ssl_remove_session(SSL_CTX *ssl, ngx
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && hash == node->key);
-
-        break;
     }
 
 done:
diff -ruNpw nginx-1.1.15/src/http/modules/ngx_http_limit_conn_module.c nginx-1.1.15_zls/src/http/modules/ngx_http_limit_conn_module.c
--- nginx-1.1.15/src/http/modules/ngx_http_limit_conn_module.c	2012-02-10 18:48:58.000000000 +0800
+++ nginx-1.1.15_zls/src/http/modules/ngx_http_limit_conn_module.c	2012-02-27 10:57:47.420637733 +0800
@@ -325,7 +325,6 @@ ngx_http_limit_conn_lookup(ngx_rbtree_t 
 
         /* hash == node->key */
 
-        do {
             lcn = (ngx_http_limit_conn_node_t *) &node->color;
 
             rc = ngx_memn2cmp(vv->data, lcn->data,
@@ -335,10 +334,6 @@ ngx_http_limit_conn_lookup(ngx_rbtree_t 
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && hash == node->key);
-
-        break;
     }
 
     return NULL;
diff -ruNpw nginx-1.1.15/src/http/modules/ngx_http_limit_req_module.c nginx-1.1.15_zls/src/http/modules/ngx_http_limit_req_module.c
--- nginx-1.1.15/src/http/modules/ngx_http_limit_req_module.c	2012-01-30 21:19:25.000000000 +0800
+++ nginx-1.1.15_zls/src/http/modules/ngx_http_limit_req_module.c	2012-02-27 10:56:59.349633483 +0800
@@ -385,7 +385,6 @@ ngx_http_limit_req_lookup(ngx_http_limit
 
         /* hash == node->key */
 
-        do {
             lr = (ngx_http_limit_req_node_t *) &node->color;
 
             rc = ngx_memn2cmp(data, lr->data, len, (size_t) lr->len);
@@ -422,10 +421,6 @@ ngx_http_limit_req_lookup(ngx_http_limit
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && hash == node->key);
-
-        break;
     }
 
     *ep = 0;
diff -ruNpw nginx-1.1.15/src/http/ngx_http_file_cache.c nginx-1.1.15_zls/src/http/ngx_http_file_cache.c
--- nginx-1.1.15/src/http/ngx_http_file_cache.c	2012-02-13 23:41:11.000000000 +0800
+++ nginx-1.1.15_zls/src/http/ngx_http_file_cache.c	2012-02-27 10:59:32.615211983 +0800
@@ -799,7 +799,6 @@ ngx_http_file_cache_lookup(ngx_http_file
 
         /* node_key == node->key */
 
-        do {
             fcn = (ngx_http_file_cache_node_t *) node;
 
             rc = ngx_memcmp(&key[sizeof(ngx_rbtree_key_t)], fcn->key,
@@ -810,10 +809,6 @@ ngx_http_file_cache_lookup(ngx_http_file
             }
 
             node = (rc < 0) ? node->left : node->right;
-
-        } while (node != sentinel && node_key == node->key);
-
-        break;
     }
 
     /* not found */